<?php
/*
Plugin Name:Tweet To Markov
Description:検索したツイートを元に自動文章生成
Version: 1.0
Author: Y.ikeda
Author URI: http://55w.jp
*/
function get_ttm($max_length = 120){

	//APIキーを登録。取得はhttps://e.developer.yahoo.co.jp/webservices/register_applicationから
	$option_value=get_option('Tweet_To_Markov_Option');
	if($option_value[0]){
		$aid = $option_value[0];
	}else{
		return "Error01:APIキーが登録されていません。";
	}
	
	//検索キーワード。Twitterの検索条件が使えます。
	if($option_value[1]){
		$seachword = $option_value[1];
	}else{
		return "Error02:検索ワードが登録されていません。";
	}
	
	$query = "q=" . $seachword;
	
	//一度に読み込む件数
	$rpp = $option_value[2];
	if($rpp){$query .= '&rpp=' . $rpp;}
	$uri = "http://search.twitter.com/search.atom?{$query}";
	include_once(ABSPATH . WPINC . '/feed.php');
	$rss = fetch_feed($uri);
	$content="";
	if($option_value[3]){
		$chash_time = $option_value[3];
	}else{
		$chash_time=300;
	}
	
	$filename=WP_PLUGIN_DIR . '/tweet_to_markov/tweet_data.xml';
	
	if ( !is_wp_error( $rss ) ){
		//feach_feedの初期設定 キャッシュ５分
		$rss->set_cache_duration($chash_time);
		$rss->init();
		$maxitems = $rss->get_item_quantity($rpp);	
		$rss_items = $rss->get_items(0, $maxitems);
				
		$yahoo_flag=0;
		if(file_exists($filename)){
			if(mktime()>filemtime($filename)+$chash_time){
				$yahoo_flag=1;
			}
	    }else{ 
	       $yahoo_flag=1;
	    } 
		
		if($yahoo_flag){
			//title部分(Twitterの整形前のソース）を件数分取得
			foreach ( $rss_items as $item ) {	
				$content .= $item->get_title() . "\n";
			}
			
			//ハッシュタグとリプライとリンクは削除。
			$content = preg_replace('/(#)(\w+)/','',$content);
			$content = preg_replace('/(@)(\w+)/','',$content);
			$content = preg_replace('/(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)/','',$content);
			
			//テキストの合計文字数を制限
			$content = substr( $content, 0, 35500 );
			
			//yahoo日本語形態素解析の設定
			$url = "http://jlp.yahooapis.jp/MAService/V1/parse";
			$data = array('appid' => $aid,'sentence' => $content,'results' => 'ma,uniq');
			$options = array('http' => array(
				'method' => 'POST',
				'content' => http_build_query($data)
			));
			
			//日本語形態素解析開始
			$word_xml = file_get_contents($url, false, stream_context_create($options));
			$fp = fopen($filename, 'w');
			fwrite( $fp, $word_xml);
			fclose($fp);
			$xml = simplexml_load_string($word_xml);
			//echo "解析";
		}else{
			$xml = simplexml_load_file($filename);
			//echo "キャッシュ";
		}
		
		
		//ワードが存在し、かつ半角全角スペースでない場合ワード登録
		foreach($xml->ma_result->word_list->word as $value){
			if(preg_match("/(.+)/",$value->surface) && !preg_match("/(\s|　)/",$value->surface)){$words[] = (string)$value->surface;}
		}
		
		//よく出るワードTOP10を設定
		$rank=0;
		$pattern = "/(";
		foreach($xml->uniq_result->word_list->word as $value){
			if($value->pos == "名詞"){
				$pattern .= $value->surface;$rank++;
				if($rank==10){break;}else{$pattern .= "|";}
			}
		}
		$pattern .= ")/";
		$words[] = "\n";
		

	if ($words) { //分かち書きデータがあれば
		$head   = array();
		$word   = array(null, null, null,null);
		$markov = array();
		
		for ($i=0 ; $i<count($words) ; $i++) {
			if ($word[0] === null) {
		      $word[0] = $words[$i];
		    } elseif ($word[1] === null) {
		      $word[1] = $words[$i];
			} elseif ($word[2] === null) {
		      $word[2] = $words[$i];
		    } else {
			
			//頻出単語 Top10 を文頭候補にする
			
      		if(preg_match($pattern,$word[0])) {
		    	$head[] = array("",$word[0], $word[1], $word[2]);
			}
			
		      //マルコフ連鎖用テーブル
		      if (!(isset($markov[$word[0]][$word[1]][$word[2]]) && is_array($markov[$word[0]][$word[1]][$word[2]]))) {
		        $markov[$word[0]][$word[1]][$word[2]] = array();
		      }
		      $markov[$word[0]][$word[1]][$word[2]][] = array($word[0], $word[1],$word[2],$words[$i]);
		      $word[0] = $words[$i - 2];
		      $word[1] = $words[$i - 1];
			  $word[2] = $words[$i];
		    }
		}
		  //頻出単語 Top10 の内のどれかを文頭にする		
		  $word = $head[array_rand($head)];
		  $create_text = $word[0].$word[1].$word[2].$word[3];
		  unset($head);
		  // マルコフ連鎖で文章生成
		  $break_flag=0;
		  for ($i=0 ; $i<500 ; $i++) { //無限ループ回避
		    // つながりは選択できる中からランダムに選択
		    if (isset($markov[$word[1]][$word[2]][$word[3]]) && is_array($markov[$word[1]][$word[2]][$word[3]])) {
		      $word = $markov[$word[1]][$word[2]][$word[3]][array_rand($markov[$word[1]][$word[2]][$word[3]])];
			  //連鎖した結果最大文字数を超えそうなら強制終了
			  if (mb_strlen($create_text . $word[3]) >= $max_length){$break_flag=1;break;}
			  //語尾が。で終わり、かつ文字制限の8割を超えてる場合強制終了
			  if($word[3] == "。" && mb_strlen($create_text . $word[3]) >= $max_length*0.8){$create_text .= $word[3];$break_flag=1;break;}			  
		      $create_text .= $word[3];
		      $create_text = preg_replace('/[[^]]*]/', "", $create_text);
		    } else {
		      break;
		    }
		    //文章終わり
		    if ($break_flag) break;
		  }
		  unset($word);
		  unset($markov);  
		
		return $create_text;
	} else {
		return "データがありませんでした";
	}		
		
	}
}



add_action('admin_menu', 'ttm_plugin_setthing_option_menu');
function ttm_plugin_setthing_option_menu(){
	add_options_page('Tweet To Markov', 'Tweet To Markov設定', 8, __FILE__, 'ttm_plugin_setthing_option');
}

function ttm_plugin_setthing_option(){
if($_POST['action'] == "update"){
	$err_msg	= "";
	$option_value[0]=$_POST['api_key'];
	$option_value[1]=$_POST['keyword'];
	$option_value[2]=$_POST['rpp'];
	$option_value[3]=$_POST['chash_time'];
	update_option('Tweet_To_Markov_Option',$option_value);
}
$option_value=get_option('Tweet_To_Markov_Option');
if(!is_numeric($option_value[2])){$option_value[2]=20;}
if(!is_numeric($option_value[3])){$option_value[3]=300;}
?>
<div class="wrap">
	<h2>Tweet To Markov設定 </h2>

<form method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
	<?php wp_nonce_field('update-options'); ?>
		<?php if($_POST['action'] == "update" && !$_POST['api_key']):?>
			<div class='updated'><p><strong>APIキーが入力されてません</strong></p></div>
		<?php endif;?>
		<?php if($_POST['action'] == "update" && !$_POST['keyword']):?>
			<div class='updated'><p><strong>検索ワードが入力されていません</strong></p></div>
		<?php endif;?>
	<table class="form-table">

		<tr valign="top">
			<th scope="row">YahooAPIキー</th>
			<td><input type="text" name="api_key" value="<?php echo $option_value[0]; ?>" />
			YahooAPIキーを入力してください。ない人は<a href="https://e.developer.yahoo.co.jp/webservices/register_application">こちら</a>から
			</td>
		</tr>

		
 		<tr valign="top">
			<th scope="row">検索ワード</th>
			<td><input type="text" name="keyword" value="<?php echo $option_value[1]; ?>" />
			Twitterから取得する検索ワードを入力してください。
			</td>
		</tr>

		
 		<tr valign="top">
			<th scope="row">読み込み件数</th>
			<td><input type="text" name="rpp" value="<?php echo $option_value[2]; ?>" />
			読み込むツイート数を入力してください。多い方が精度が上がりますが読み込み速度が遅くなります。
			</td>
		</tr>

		<tr valign="top">
			<th scope="row">キャッシュ時間</th>
			<td><input type="text" name="chash_time" value="<?php echo $option_value[3]; ?>" />
			キャッシュ時間を入力してください。あまり短いと負荷がかかります。
			</td>
		</tr>		 
	</table>

	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="new_option_name,some_other_option,option_etc" />

	<p class="submit">
	<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
	</p>

</form>
</div>
<?php
}
?>